
#define		VIDEO		0x10	/* BIOS video int. */
#define		WRT_PIX		0x0c	/* BIOS write pixel request */
#define		SET_MODE	0	/* BIOS set video mode: al = video mode */
#define		VIDEO_STATE	0x0f	/* BIOS get video state */
#define		SET_COLOR	0x0b	/* setup color pallate request */
#define		CGA_MED		4	/* BIOS CGA 320x200 color */
#define		CGA_HIGH	6	/* BIOS CGA 640x200 BW */
#define		ATT_HIRES	0x48	/* AT&T 640x400 mode, tiny type */
#define		EGA_LORES	0xd	/* IBM EGA low-res mode (320x200) */
#define		EGA_MEDRES	0xe	/* IBM EGA med-res mode (640x200) */
#define		EGA_HIRES	0x10	/* IBM EGA high-res mode (640x350) */
#define		VGA_HIRES	0x12	/* IBM VGA high-res mode (640x480) */
#define		VGA_LORES	0x13	/* IBM VGA lo-res mode (320x200) */

void drawline ( int, int, int, int );
void putdot ( int, int );
void write_char ( char *, int, int );
void draw_c ( char );


void clip ( double, double, double, double );
void csize ( double, double, double );
void deg ();
void draw ( double, double );
void frame ();
void graphics_off ();
void g_init ();
void idraw ( double, double );
void imove ( double, double );
void iplot ( double, double, int );
void labelf ( char *, ... );
void line_type ( int, double );
void ldir ( double );
void limit ( double, double, double, double );
void locate ( double, double, double, double );
void lorg ( int );
void move ( double, double );
void mscale ( double, double );
void pdir ( double );
void pen ( int );
void penup ();
void pivot ( double );
void plot ( double, double, int );
void rad ();
double ratio();
void rdraw ( double, double );
void rmove ( double, double );
void rplot ( double, double, int );
void scale ( double, double, double, double );
void setgu ();
void setuu ();
void show ( double, double, double, double );
void unclip ();


