
#define		VIDEO		0x10	/* BIOS video int. */
#define		WRT_PIX		0x0c	/* BIOS write pixel request */
#define		SET_MODE	0	/* BIOS set video mode: al = video mode */
#define		VIDEO_STATE	0x0f	/* BIOS get video state */
#define		SET_COLOR	0x0b	/* setup color pallate request */
#define		CGA_320x200	1	/* BIOS CGA 320x200, 4 color */
#define		CGA_640x200	2	/* BIOS CGA 640x200 BW */
#define		ATT_640x400	3	/* AT&T 640x400 BW, tiny type */
#define		EGA_320x200	4	/* IBM EGA low-res 320x200, 16 color */
#define		EGA_640x200	5	/* IBM EGA med-res 640x200, 16 color */
#define		EGA_640x350	6	/* IBM EGA high-res 640x350, 16 color */
#define		VGA_640x480	7	/* IBM VGA high-res 640x480, 16 color */
#define		VGA_320x200	8	/* IBM VGA lo-res 320x200, 256 color */

void clip ( double, double, double, double );
void csize ( double, double, double );
void deg ();
void draw ( double, double );
void frame ();
void graphics_off ();
void g_init ();
void idraw ( double, double );
void imove ( double, double );
void iplot ( double, double, int );
void labelf ( char *, ... );
void line_type ( int, double );
void ldir ( double );
void limit ( double, double, double, double );
void locate ( double, double, double, double );
void lorg ( int );
void move ( double, double );
void mscale ( double, double );
void penup ();
void pdir ( double );
void pen ( int );
void pivot ( double );
void plot ( double, double, int );
void rad ();
double ratio ();
void rdraw ( double, double );
void rmove ( double, double );
void rplot ( double, double, int );
void scale ( double, double, double, double );
void setgu ();
void setuu ();
void show ( double, double, double, double );
void unclip ();

extern double X_mm = 220.0, Y_mm = 160.0;	/* screen size in mm */

